.NOLIST
#include "ti83asm.inc"
.LIST
.org progstart
; 1: locate real number
; 2: convert real number into string
; 3: delete ans
; 4: create string ans
; 5: copy string into ans


; 1: locate real number:
 bcall(_zeroop1)
 ld a,Tans
 ld (op1+1),a
 bcall(_findsym)
 jp c,_ERRUNDEFINED
 and $1F
 jp nz,_ERRDATATYPE

; 2: convert real number into string
 ex de,hl
 bcall(_Mov9ToOp1)		; copy ans into op1
 ld a,11			; maximum length of string
 bcall(_FormReal)		; convert the real # in op1 to a string in op3
 push bc

; 3: delete ans:
 bcall(_zeroop1)
 ld a,Tans
 ld (op1+1),a
 bcall(_findsym)
 bcall(_DelVar)

; 4: create string ans:
 bcall(_zeroop1)
 ld a,StrngObj
 ld (op1),a
 ld a,Tans
 ld (op1+1),a
 pop hl
 push hl
 bcall(_createstrng)

; 5: copy string into ans
 inc de
 inc de		; de=ans adr
 pop bc		; bc=length
 ld b,c
 ld hl,op3	; string location
COPY_LOOP:
 ld a,(hl)
 cp $1B		; Exponent char
 jr nz,NO_EXPONENT
 ld a,$3B	; exponent token
NO_EXPONENT:
 cp $2E		; period char
 jr nz,NO_PERIOD
 ld a,$3A	; period token
NO_PERIOD:
 ld (de),a
 inc hl
 inc de
 djnz COPY_LOOP
 ldir

 ret
.end
END

